module Queens where

import Fd
import IO

mapc        :: (a -> Success) -> [a] -> Success
mapc _ []     = success
mapc f (x:xs) = (f x) & (mapc f xs)

-- Set the constraints on the queens.
gen_list :: Int -> [Int] 
gen_list n = 
    if n == 0 then [] 
       else let x free 
                xs = gen_list (n-1) in
                     (x : xs)

no_attack                   :: [Int] -> Int -> Int -> Success
no_attack [] _ _            = success
no_attack (x : xs) queen nb = 
    no_attack xs queen (nb + 1) & queen .<>. x .+. nb & queen .<>. x .-. nb

no_attack_all :: [Int] -> [Int]
no_attack_all [] = []
no_attack_all (x:xs) = no_attack xs x 1 &> (x: (no_attack_all xs))

constraint_values :: [Int] -> Int -> [Int]
constraint_values l n = map (\v -> in_range v (1,n) &> v) l

queens :: Int -> [Int]
queens n = let l= constraint_values (gen_list n) n in labeling ( (tonf (all_different (tonf (no_attack_all (tonf l))))))

main = printLn $ queens 5
